summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author William PC2022-10-01 00:11:37 +0200
committer Willy Sudiarto Raharjo2022-10-01 04:01:16 +0200
commitd1301168987ead4227c523b9dd837ff581f09120 (patch)
treea0bc7de4e7917783578ebe1812fd3d89308e8197
parente3ef3470f54a26e24cf26a5c0a346ce9cbe9b73f (diff)
downloadslackbuilds-d1301168987ead4227c523b9dd837ff581f09120.tar.gz
libraries/blis: Added (BLAS-like dense linear algebra libraries)
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/blis/README10
-rw-r--r--libraries/blis/blis.SlackBuild114
-rw-r--r--libraries/blis/blis.info10
-rw-r--r--libraries/blis/slack-desc19
4 files changed, 153 insertions, 0 deletions
diff --git a/libraries/blis/README b/libraries/blis/README
new file mode 100644
index 0000000000..79c76866d8
--- /dev/null
+++ b/libraries/blis/README
@@ -0,0 +1,10 @@
+ BLIS is a portable software framework for instantiating
+high-performance BLAS-like dense linear algebra libraries.
+The framework was designed to isolate essential kernels of computation
+that, when optimized, immediately enable optimized implementations of
+most of its commonly used and computationally intensive operations.
+BLIS is written in ISO C99 and available under a new/modified/3-clause
+BSD license. While BLIS exports a new BLAS-like API, it also includes
+a BLAS compatibility layer which gives application developers access
+to BLIS implementations via traditional BLAS routine calls.
+An object-based API unique to BLIS is also available.
diff --git a/libraries/blis/blis.SlackBuild b/libraries/blis/blis.SlackBuild
new file mode 100644
index 0000000000..b296d3df15
--- /dev/null
+++ b/libraries/blis/blis.SlackBuild
@@ -0,0 +1,114 @@
+#!/bin/bash
+
+# Slackware build script for BLIS
+
+# Copyright 2022 William PC - Seattle, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=blis
+VERSION=${VERSION:-0.8.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --disable-static \
+ generic
+
+make
+make check
+make install DESTDIR=$PKG
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG -depth -type d -empty -delete || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a {CHANGELOG,CONTRIBUTING.md,CREDITS,LICENSE,RELEASING,version} $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a docs/*.* $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/blis/blis.info b/libraries/blis/blis.info
new file mode 100644
index 0000000000..6f020d63c5
--- /dev/null
+++ b/libraries/blis/blis.info
@@ -0,0 +1,10 @@
+PRGNAM="blis"
+VERSION="0.8.1"
+HOMEPAGE="https://github.com/flame/blis"
+DOWNLOAD="https://github.com/flame/blis/archive/0.8.1/blis-0.8.1.tar.gz"
+MD5SUM="26e0ce355b7021b178da86ba75cdb2c4"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="William PC"
+EMAIL="w_calandrini[at]hotmail[dot]com"
diff --git a/libraries/blis/slack-desc b/libraries/blis/slack-desc
new file mode 100644
index 0000000000..8da1b2d9b2
--- /dev/null
+++ b/libraries/blis/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+blis: blis (high-performance BLAS-like dense linear algebra libraries)
+blis:
+blis: BLIS is a portable software framework for instantiating
+blis: high-performance BLAS-like dense linear algebra libraries.
+blis: The framework was designed to isolate essential kernels of
+blis: computation that, when optimized, immediately enable optimized
+blis: implementations of most of its commonly used and computationally
+blis: intensive operations. BLIS is written in ISO C99 and available
+blis: under a new/modified/3-clause BSD license.
+blis:
+blis: